Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdf_oce.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdf_oce.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdf_oce.F90	(revision 9019)
@@ -4,6 +4,7 @@
    !! Ocean physics : define vertical mixing variables
    !!=====================================================================
-   !! history :  1.0  !  2002-06  (G. Madec) Original code
-   !!            3.2  !  2009-07  (G.Madec) addition of avm
+   !! history :  1.0  !  2002-06  (G. Madec)  Original code
+   !!            3.2  !  2009-07  (G. Madec)  addition of avm
+   !!            4.0  !  2017-05  (G. Madec)  avm and drag coef. defined at t-point
    !!----------------------------------------------------------------------
    USE par_oce        ! ocean parameters
@@ -16,38 +17,40 @@
    PUBLIC  zdf_oce_alloc    ! Called in nemogcm.F90
 
-#if defined key_zdfcst
-   LOGICAL, PARAMETER, PUBLIC ::   lk_zdfcst        = .TRUE.         !: constant vertical mixing flag
-#else
-   LOGICAL, PARAMETER, PUBLIC ::   lk_zdfcst        = .FALSE.        !: constant vertical mixing flag
-#endif
-
-   !                                 !!* namelist namzdf: vertical diffusion *
+   !                            !!* namelist namzdf: vertical physics *
+   !                             ! vertical closure scheme flags
+   LOGICAL , PUBLIC ::   ln_zdfcst   !: constant coefficients
+   LOGICAL , PUBLIC ::   ln_zdfric   !: Richardson depend coefficients
+   LOGICAL , PUBLIC ::   ln_zdftke   !: Turbulent Kinetic Energy closure
+   LOGICAL , PUBLIC ::   ln_zdfgls   !: Generic Length Scale closure
+   LOGICAL , PUBLIC ::   ln_zdfosm   !: OSMOSIS BL closure
+   !                             ! convection
+   LOGICAL , PUBLIC ::   ln_zdfevd   !: convection: enhanced vertical diffusion flag
+   INTEGER , PUBLIC ::      nn_evdm     !: =0/1 flag to apply enhanced avm or not
+   REAL(wp), PUBLIC ::      rn_evd      !: vertical eddy coeff. for enhanced vert. diff. (m2/s)
+   LOGICAL , PUBLIC ::   ln_zdfnpc   !: convection: non-penetrative convection flag
+   INTEGER , PUBLIC ::      nn_npc      !: non penetrative convective scheme call  frequency
+   INTEGER , PUBLIC ::      nn_npcp     !: non penetrative convective scheme print frequency
+   !                             ! double diffusion
+   LOGICAL , PUBLIC ::   ln_zdfddm   !: double diffusive mixing flag
+   REAL(wp), PUBLIC ::      rn_avts     !: maximum value of avs for salt fingering
+   REAL(wp), PUBLIC ::      rn_hsbfr    !: heat/salt buoyancy flux ratio
+   !                             ! gravity wave-induced vertical mixing
+   LOGICAL , PUBLIC ::   ln_zdfswm   !: surface  wave-induced mixing flag
+   LOGICAL , PUBLIC ::   ln_zdfiwm   !: internal wave-induced mixing flag
+   !                             ! coefficients 
    REAL(wp), PUBLIC ::   rn_avm0     !: vertical eddy viscosity (m2/s)
    REAL(wp), PUBLIC ::   rn_avt0     !: vertical eddy diffusivity (m2/s)
    INTEGER , PUBLIC ::   nn_avb      !: constant or profile background on avt (=0/1)
-   INTEGER , PUBLIC ::   nn_havtb    !: horizontal shape or not for avtb (=0/1)
-   LOGICAL , PUBLIC ::   ln_zdfexp   !: explicit vertical diffusion scheme flag
-   INTEGER , PUBLIC ::   nn_zdfexp   !: number of sub-time step (explicit time stepping)
-   LOGICAL , PUBLIC ::   ln_zdfevd   !: convection: enhanced vertical diffusion flag
-   INTEGER , PUBLIC ::   nn_evdm     !: =0/1 flag to apply enhanced avm or not
-   REAL(wp), PUBLIC ::   rn_avevd    !: vertical eddy coeff. for enhanced vert. diff. (m2/s)
-   LOGICAL , PUBLIC ::   ln_zdfnpc   !: convection: non-penetrative convection flag
-   INTEGER , PUBLIC ::   nn_npc      !: non penetrative convective scheme call  frequency
-   INTEGER , PUBLIC ::   nn_npcp     !: non penetrative convective scheme print frequency
-   LOGICAL , PUBLIC ::   ln_zdfqiao  !: Enhanced wave vertical mixing Qiao(2010) formulation flag
+   INTEGER , PUBLIC ::   nn_havtb    !: horizontal shape or not for avtb (=0/1)   !                             ! convection
 
 
-   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::   avmb , avtb    !: background profile of avm and avt
-   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   avtb_2d        !: horizontal shape of background Kz profile
-   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   bfrua, bfrva   !: Bottom friction coefficients set in zdfbfr
-   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   tfrua, tfrva   !: top friction coefficients set in zdfbfr
-   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   avmu , avmv    !: vertical viscosity coef at uw- & vw-pts       [m2/s]
-   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   avm  , avt     !: vertical viscosity & diffusivity coef at w-pt [m2/s]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   avt_k , avm_k  ! not enhanced Kz
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   avmu_k, avmv_k ! not enhanced Kz
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   en              !: now turbulent kinetic energy   [m2/s2]
+   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   avm, avt, avs  !: vertical mixing coefficients (w-point) [m2/s]
+   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   avm_k , avt_k  !: Kz computed by turbulent closure alone [m2/s]
+   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   en             !: now turbulent kinetic energy          [m2/s2]
+   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::   avmb , avtb    !: background profile of avm and avt      [m2/s]
+   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   avtb_2d        !: horizontal shape of background Kz profile [-]
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2017)
    !! $Id$ 
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -60,12 +63,7 @@
       !!----------------------------------------------------------------------
       !
-      ALLOCATE(avmb(jpk) , bfrua(jpi,jpj) ,                         &
-         &     avtb(jpk) , bfrva(jpi,jpj) , avtb_2d(jpi,jpj) ,      &
-         &     tfrua(jpi, jpj), tfrva(jpi, jpj)              ,      &
-         &     avmu  (jpi,jpj,jpk), avm   (jpi,jpj,jpk)      ,      &
-         &     avmv  (jpi,jpj,jpk), avt   (jpi,jpj,jpk)      ,      &
-         &     avt_k (jpi,jpj,jpk), avm_k (jpi,jpj,jpk)      ,      & 
-         &     avmu_k(jpi,jpj,jpk), avmv_k(jpi,jpj,jpk)      ,      &
-         &     en    (jpi,jpj,jpk), STAT = zdf_oce_alloc )
+      ALLOCATE( avm (jpi,jpj,jpk) , avm_k(jpi,jpj,jpk) , avs(jpi,jpj,jpk) ,   &
+         &      avt (jpi,jpj,jpk) , avt_k(jpi,jpj,jpk) , en (jpi,jpj,jpk) ,   & 
+         &      avmb(jpk)         , avtb(jpk)          , avtb_2d(jpi,jpj) , STAT = zdf_oce_alloc )
          !
       IF( zdf_oce_alloc /= 0 )   CALL ctl_warn('zdf_oce_alloc: failed to allocate arrays')
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfddm.F90	(revision 9019)
@@ -8,23 +8,20 @@
    !!            3.3  ! 2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
    !!            3.6  ! 2013-04  (G. Madec, F. Roquet) zrau compute locally using interpolation of alpha & beta
+   !!            4.0  !  2017-04  (G. Madec)  remove CPP ddm key & avm at t-point only 
    !!----------------------------------------------------------------------
-#if defined key_zdfddm
+
    !!----------------------------------------------------------------------
-   !!   'key_zdfddm' :                                     double diffusion
+   !!   zdf_ddm       : compute the Kz for salinity
    !!----------------------------------------------------------------------
-   !!   zdf_ddm       : compute the Ks for salinity
-   !!   zdf_ddm_init  : read namelist and control the parameters
-   !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers variables
-   USE dom_oce         ! ocean space and time domain variables 
-   USE zdf_oce         ! ocean vertical physics variables
+   USE oce            ! ocean dynamics and tracers variables
+   USE dom_oce        ! ocean space and time domain variables
+   USE zdf_oce        ! ocean vertical physics variables
    USE eosbn2         ! equation of state
    !
-   USE in_out_manager  ! I/O manager
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE prtctl          ! Print control
-   USE lib_mpp         ! MPP library
-   USE wrk_nemo        ! work arrays
-   USE timing          ! Timing
+   USE in_out_manager ! I/O manager
+   USE lbclnk         ! ocean lateral boundary conditions (or mpp link)
+   USE prtctl         ! Print control
+   USE lib_mpp        ! MPP library
+   USE timing         ! Timing
 
    IMPLICIT NONE
@@ -32,14 +29,4 @@
 
    PUBLIC   zdf_ddm       ! called by step.F90
-   PUBLIC   zdf_ddm_init  ! called by opa.F90
-   PUBLIC   zdf_ddm_alloc ! called by nemogcm.F90
-
-   LOGICAL , PUBLIC, PARAMETER ::   lk_zdfddm = .TRUE.  !: double diffusive mixing flag
-
-   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::   avs   !: salinity vertical diffusivity coeff. at w-point
-
-   !                       !!* Namelist namzdf_ddm : double diffusive mixing *
-   REAL(wp) ::   rn_avts    ! maximum value of avs for salt fingering
-   REAL(wp) ::   rn_hsbfr   ! heat/salt buoyancy flux ratio
 
    !! * Substitutions
@@ -52,15 +39,5 @@
 CONTAINS
 
-   INTEGER FUNCTION zdf_ddm_alloc()
-      !!----------------------------------------------------------------------
-      !!                ***  ROUTINE zdf_ddm_alloc  ***
-      !!----------------------------------------------------------------------
-      ALLOCATE( avs(jpi,jpj,jpk) , STAT= zdf_ddm_alloc )
-      IF( lk_mpp             )   CALL mpp_sum ( zdf_ddm_alloc )
-      IF( zdf_ddm_alloc /= 0 )   CALL ctl_warn('zdf_ddm_alloc: failed to allocate arrays')
-   END FUNCTION zdf_ddm_alloc
-
-
-   SUBROUTINE zdf_ddm( kt )
+   SUBROUTINE zdf_ddm( kt, p_avm, p_avt, p_avs )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE zdf_ddm  ***
@@ -86,5 +63,5 @@
       !!      avt = avt + zavft + zavdt
       !!      avs = avs + zavfs + zavds
-      !!      avmu, avmv are required to remain at least above avt and avs.
+      !!      avm is required to remain at least above avt and avs.
       !!      
       !! ** Action  :   avt, avs : updated vertical eddy diffusivity coef. for T & S
@@ -92,5 +69,8 @@
       !! References :   Merryfield et al., JPO, 29, 1124-1142, 1999.
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt   ! ocean time-step indexocean time step
+      INTEGER, INTENT(in   ) ::   kt       ! ocean time-step indexocean time step
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   p_avm   !  Kz on momentum    (w-points)
+      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   p_avt   !  Kz on temperature (w-points)
+      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   p_avs   !  Kz on salinity    (w-points)
       !
       INTEGER  ::   ji, jj , jk     ! dummy loop indices
@@ -100,10 +80,8 @@
       REAL(wp) ::   zavft, zavfs    !   -      -
       REAL(wp) ::   zavdt, zavds    !   -      -
-      REAL(wp), POINTER, DIMENSION(:,:) ::   zrau, zmsks, zmskf, zmskd1, zmskd2, zmskd3
+      REAL(wp), DIMENSION(jpi,jpj) ::   zrau, zmsks, zmskf, zmskd1, zmskd2, zmskd3
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('zdf_ddm')
-      !
-      CALL wrk_alloc( jpi,jpj, zrau, zmsks, zmskf, zmskd1, zmskd2, zmskd3 )
+      IF( ln_timing )   CALL timing_start('zdf_ddm')
       !
       !                                                ! ===============
@@ -112,7 +90,12 @@
          ! Define the mask 
          ! ---------------
-         DO jj = 1, jpj                                ! R=zrau = (alpha / beta) (dk[t] / dk[s])
+!!gm  WORK to be done:   change the code from vector optimisation to scalar one.
+!!gm                     ==>>>  test in the loop instead of use of mask arrays
+!!gm                            and many acces in memory
+         
+         DO jj = 1, jpj                !==  R=zrau = (alpha / beta) (dk[t] / dk[s])  ==!
             DO ji = 1, jpi
                zrw =   ( gdepw_n(ji,jj,jk  ) - gdept_n(ji,jj,jk) )   &
+!!gm please, use e3w_n below 
                   &  / ( gdept_n(ji,jj,jk-1) - gdept_n(ji,jj,jk) ) 
                !
@@ -129,5 +112,5 @@
          END DO
 
-         DO jj = 1, jpj                                     ! indicators:
+         DO jj = 1, jpj                !==  indicators  ==!
             DO ji = 1, jpi
                ! stability indicator: msks=1 if rn2>0; 0 elsewhere
@@ -174,27 +157,7 @@
                   &                             +  0.15 * zrau(ji,jj)          * zmskd2(ji,jj)  )
                ! add to the eddy viscosity coef. previously computed
-# if defined key_zdftmx_new
-               ! key_zdftmx_new: New internal wave-driven param: use avs value computed by zdftmx
-               avs (ji,jj,jk) = avs(ji,jj,jk) + zavfs + zavds
-# else
-               avs (ji,jj,jk) = avt(ji,jj,jk) + zavfs + zavds
-# endif
-               avt (ji,jj,jk) = avt(ji,jj,jk) + zavft + zavdt
-               avm (ji,jj,jk) = avm(ji,jj,jk) + MAX( zavft + zavdt, zavfs + zavds )
-            END DO
-         END DO
-
-
-         ! Increase avmu, avmv if necessary
-         ! --------------------------------
-!!gm to be changed following the definition of avm.
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               avmu(ji,jj,jk) = MAX( avmu(ji,jj,jk),    &
-                  &                  avt(ji,jj,jk), avt(ji+1,jj,jk),   &
-                  &                  avs(ji,jj,jk), avs(ji+1,jj,jk) )  * wumask(ji,jj,jk)
-               avmv(ji,jj,jk) = MAX( avmv(ji,jj,jk),    &
-                  &                  avt(ji,jj,jk), avt(ji,jj+1,jk),   &
-                  &                  avs(ji,jj,jk), avs(ji,jj+1,jk) )  * wvmask(ji,jj,jk)
+               p_avs(ji,jj,jk) = p_avt(ji,jj,jk) + zavfs + zavds
+               p_avt(ji,jj,jk) = p_avt(ji,jj,jk) + zavft + zavdt
+               p_avm(ji,jj,jk) = p_avm(ji,jj,jk) + MAX( zavft + zavdt, zavfs + zavds )
             END DO
          END DO
@@ -203,75 +166,12 @@
       !                                                   ! ===============
       !
-      CALL lbc_lnk( avt , 'W', 1._wp )     ! Lateral boundary conditions   (unchanged sign)
-      CALL lbc_lnk( avs , 'W', 1._wp )
-      CALL lbc_lnk( avm , 'W', 1._wp )
-      CALL lbc_lnk( avmu, 'U', 1._wp ) 
-      CALL lbc_lnk( avmv, 'V', 1._wp )
-
       IF(ln_ctl) THEN
          CALL prt_ctl(tab3d_1=avt , clinfo1=' ddm  - t: ', tab3d_2=avs , clinfo2=' s: ', ovlap=1, kdim=jpk)
-         CALL prt_ctl(tab3d_1=avmu, clinfo1=' ddm  - u: ', mask1=umask, &
-            &         tab3d_2=avmv, clinfo2=       ' v: ', mask2=vmask, ovlap=1, kdim=jpk)
       ENDIF
       !
-      CALL wrk_dealloc( jpi,jpj, zrau, zmsks, zmskf, zmskd1, zmskd2, zmskd3 )
-      !
-      IF( nn_timing == 1 )  CALL timing_stop('zdf_ddm')
+      IF( ln_timing )   CALL timing_stop('zdf_ddm')
       !
    END SUBROUTINE zdf_ddm
    
-   
-   SUBROUTINE zdf_ddm_init
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE zdf_ddm_init  ***
-      !!
-      !! ** Purpose :   Initialization of double diffusion mixing scheme
-      !!
-      !! ** Method  :   Read the namzdf_ddm namelist and check the parameter values
-      !!              called by zdf_ddm at the first timestep (nit000)
-      !!----------------------------------------------------------------------
-      INTEGER ::   ios   ! local integer
-      !!
-      NAMELIST/namzdf_ddm/ rn_avts, rn_hsbfr
-      !!----------------------------------------------------------------------
-      !
-      REWIND( numnam_ref )              ! Namelist namzdf_ddm in reference namelist : Double diffusion mixing scheme
-      READ  ( numnam_ref, namzdf_ddm, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzdf_ddm in reference namelist', lwp )
-
-      REWIND( numnam_cfg )              ! Namelist namzdf_ddm in configuration namelist : Double diffusion mixing scheme
-      READ  ( numnam_cfg, namzdf_ddm, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzdf_ddm in configuration namelist', lwp )
-      IF(lwm) WRITE ( numond, namzdf_ddm )
-      !
-      IF(lwp) THEN                    ! Parameter print
-         WRITE(numout,*)
-         WRITE(numout,*) 'zdf_ddm : double diffusive mixing'
-         WRITE(numout,*) '~~~~~~~'
-         WRITE(numout,*) '   Namelist namzdf_ddm : set dd mixing parameter'
-         WRITE(numout,*) '      maximum avs for dd mixing      rn_avts   = ', rn_avts
-         WRITE(numout,*) '      heat/salt buoyancy flux ratio  rn_hsbfr  = ', rn_hsbfr
-      ENDIF
-      !
-      !                               ! allocate zdfddm arrays
-      IF( zdf_ddm_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_ddm_init : unable to allocate arrays' )
-      !                               ! initialization to masked Kz
-      avs(:,:,:) = rn_avt0 * wmask(:,:,:) 
-      !
-   END SUBROUTINE zdf_ddm_init
-
-#else
-   !!----------------------------------------------------------------------
-   !!   Default option :          Dummy module          No double diffusion
-   !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_zdfddm = .FALSE.   !: double diffusion flag
-CONTAINS
-   SUBROUTINE zdf_ddm( kt )           ! Dummy routine
-      WRITE(*,*) 'zdf_ddm: You should not have seen this print! error?', kt
-   END SUBROUTINE zdf_ddm
-   SUBROUTINE zdf_ddm_init            ! Dummy routine
-   END SUBROUTINE zdf_ddm_init
-#endif
-
    !!======================================================================
 END MODULE zdfddm
